//source code taken from thread: 30969
//post: Tenners  2010.04.01 20:55
//'this' filename: 30969 Tenners  2010_04_01 20_55.mq4
//
//reason? making inline comments on Tenners mods
//disclaimer: ALL imho :)
//
#property indicator_chart_window
#property indicator_buffers 4             //this property's value must equate to the total # of plot buffers (those seen on chart)
#property indicator_color1 Red            //since TWO extra buffers reqd. this value must reflect that ie, 6
#property indicator_color2 Lime
#property indicator_color3 Red
#property indicator_color4 Lime           //this property allows one to set the color style for the plotted buffer
                                          //other ways are available, and even dynamically via SetIndexStyle()
                                          //the TWO extra buffers need property lines here: ..._color[5,6]
//#property indicator_color5 Yellow
//---- parameters
extern int MaMetod =2;
extern int MaPeriod=6;
extern int MaMetod2 =3;
extern int MaPeriod2=2;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double arrowUp[],arrowDn[],signal[];      //signal[] can be seen as overkill as Up,Dn will have zero or non-zero values
                                          //I would not use it also due to the fact signal[] is NOT seen by iCustom()
                                          //why? is not part of the buffers mapped into #property indicator_buffers list.
                                          //also: take a look at EMPTY_VALUE and 0.0 as these values used in indicator buffers
                                          //to say "this array[shift] element is not plotted
                                          //remember also that whatever you put into an indicator_buffer MUST allow for it to map
                                          //into the visible y-axis hi/lo range- else not much point in loading it, yes?
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
double ExtMapBuffer8[];
//----
int ExtCountedBars=0;
int firstStart = true;                    //please never use type int 'to mean' type bool, ok? maintenance will be brain killing!
                                          //additionally, the compiler is there to HELP you by doing some range/reasonableness tests.
                                          //ie, type bool can have: true or false. NOTHING else.
                                          //not tested but probably can mess with values other than these. But, this is pointless as
                                          //boolean logic is true/false! Remember also: not all languages see digit one as true
                                          //and digit two as false! ie, is implementation dependant. By using "false" or "true"
                                          //you could care less what firstStart's memory address physically contains...
                                          
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//|------------------------------------------------------------------|
int init()
  {
//---- indicators
   IndicatorBuffers(8);                   //THIS value represents the MAXIMUM # of double []'s to use as 'series arrays'
                                          //basically as you can imagine from a computing viewpoint, you cannot push a new bar's datum(s)
                                          //onto the 'front' or beginning of a memory block's adrs range. eg, you would 'append' data
                                          //to the arrays block - thus extending it. iow, [0] remains [0] and the element size grows
                                          //say for an 'originally sized' N element array eg:[0],...,[N-1] --> [N],{N+1],..
                                          //index buffers must be dynamically 'grown' as more ccy data incomes to ClientTerminal (CT)
                                          //MetaTrader decided to make index buffers 'series arrays' ie, reverse indexing.
                                          //so when you access [0] that is the latest ccy datum, yes? so where can it be? as seen above
                                          //it is the physically last [] to be appended to the 'normal' array memory area, yes? cuz no other
                                          //place to put it. Think FLAG. ie, MT flags the double [] which you have indicated is
                                          //a SetIndexBuffer() OR ArraySetAsSeries() type buffer. Simple, yes? So whenever the
                                          //interpreter access eg,[0] it 'knows' via the FLAG that it must look at the END of the array.
                                          //NOTE:obviously i not have CT internals awareness but one can make educated guess as to
                                          //underlying functionality... Ramble over.
   SetIndexStyle(0,DRAW_HISTOGRAM, 0, 1, Red);
   SetIndexBuffer(0, ExtMapBuffer1);
   SetIndexStyle(1,DRAW_HISTOGRAM, 0, 1, Lime);
   SetIndexBuffer(1, ExtMapBuffer2);
   SetIndexStyle(2,DRAW_HISTOGRAM, 0, 3, Red);
   SetIndexBuffer(2, ExtMapBuffer3);
   SetIndexStyle(3,DRAW_HISTOGRAM, 0, 3, Lime);
   SetIndexBuffer(3, ExtMapBuffer4);
    SetIndexBuffer(4,arrowUp);                                    //correct. you have added in TWO new indicator_buffers
    SetIndexStyle(4,DRAW_ARROW);                                  //see why must lockstep #property indicator_buffers/
    SetIndexArrow(4,233); //241 option for different arrow head   //and in this case must be 6 ie, #0,1,..,4,5
    SetIndexBuffer(5,arrowDn);
    SetIndexStyle(5,DRAW_ARROW);
    SetIndexArrow(5,234); //242 option for different arrow head      
//----
   SetIndexDrawBegin(0,5);
//---- indicator buffers mapping
   SetIndexBuffer(0,ExtMapBuffer1);       //NO! do you see why your chart is not as wanted?
   SetIndexBuffer(1,ExtMapBuffer2);       //erm, put another way, these are totally redundant since done above!
   SetIndexBuffer(2,ExtMapBuffer3);       //..
   SetIndexBuffer(3,ExtMapBuffer4);       //..
   SetIndexBuffer(4,arrowUp);             //..
   SetIndexBuffer(5,arrowDn);             //..
   SetIndexBuffer(6,signal);              //signal[]: even IF set this [] with values, AND bump #property .. up to 7, wats the point of it?
                                          //Up,Dn[] supply all info needed, yes? (strictly speaking you do not need any extra []'s
                                          //wat? well the following code loads Ext...1,2,3,4 and they are plotted, yes?
                                          //by getting vals from the 4 Ext bufs, you can work out WHICH candle (UP,DN) is plotted...                                          

   /*SetIndexBuffer(4,ExtMapBuffer5);     //WAIT A MO! you can of course do this and in 'firstStart' block make series arrays...
   SetIndexBuffer(5,ExtMapBuffer6);       //but why bother? if have TWO spare slots ie, indicator_buffers 6 and 7 then why not use them?
   SetIndexBuffer(6,ExtMapBuffer7);       //ref:modded code that works etc.
   SetIndexBuffer(7,ExtMapBuffer8);*/
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//---- Add extra buffers
if(firstStart == true)                    //C's as above where firstStart declared and initialised
{
   ArrayResize(ExtMapBuffer5,Bars);
   ArraySetAsSeries(ExtMapBuffer5,true);     //The setAsSeries reverses the indexing sense of the array so it's identical to the normal IndicatorBuffers.

   ArrayResize(ExtMapBuffer6,Bars);              
   ArraySetAsSeries(ExtMapBuffer5,true);          

   ArrayResize(ExtMapBuffer7,Bars);
   ArraySetAsSeries(ExtMapBuffer7,true);

   ArrayResize(ExtMapBuffer8,Bars);
   ArraySetAsSeries(ExtMapBuffer8,true);
   
   firstStart = false;
}


   double maOpen, maClose, maLow, maHigh;
   double haOpen, haHigh, haLow, haClose;
   if(Bars<=10) return(0);
   ExtCountedBars=IndicatorCounted();
//---- check for possible errors
   if (ExtCountedBars<0) return(-1);
//---- last counted bar will be recounted
   if (ExtCountedBars>0) ExtCountedBars--;
   int pos=Bars-ExtCountedBars-1;
   while(pos>=0)
     {
      maOpen=iMA(NULL,0,MaPeriod,0,MaMetod,MODE_OPEN,pos);
      maClose=iMA(NULL,0,MaPeriod,0,MaMetod,MODE_CLOSE,pos);
      maLow=iMA(NULL,0,MaPeriod,0,MaMetod,MODE_LOW,pos);
      maHigh=iMA(NULL,0,MaPeriod,0,MaMetod,MODE_HIGH,pos);
//----
      haOpen=(ExtMapBuffer5[pos+1]+ExtMapBuffer6[pos+1])/2;
      haClose=(maOpen+maHigh+maLow+maClose)/4;
      haHigh=MathMax(maHigh, MathMax(haOpen, haClose));
      haLow=MathMin(maLow, MathMin(haOpen, haClose));
      arrowUp[pos]= 0;                    //why bother initialising? below, one of the code blocks will execute, yes?
      arrowDn[pos]= 0;                    //..
      signal[pos]=0;                      //.. C's on this [] as above
      if (haOpen<haClose)
        {
         ExtMapBuffer7[pos]=haLow;
         ExtMapBuffer8[pos]=haHigh;
         arrowUp[pos]= haLow - 10 * MarketInfo(Symbol(),MODE_POINT);
         arrowDn[pos]= 0;
         signal[pos]=1;                   //.. C's on this [] as above
        }
      else
        {
         ExtMapBuffer7[pos]=haHigh;
         ExtMapBuffer8[pos]=haLow;
         arrowUp[pos]= 0;
         arrowDn[pos]= haHigh + 10 * MarketInfo(Symbol(),MODE_POINT);
         signal[pos]=-1;                  //.. C's on this [] as above and... again: -1 que? y-axis...
        }
      ExtMapBuffer5[pos]=haOpen;
      ExtMapBuffer6[pos]=haClose;
      pos--;
     }
   int i;
   for(i=0; i<Bars; i++) ExtMapBuffer1[i]=iMAOnArray(ExtMapBuffer7,Bars,MaPeriod2,0,MaMetod2,i);
   for(i=0; i<Bars; i++) ExtMapBuffer2[i]=iMAOnArray(ExtMapBuffer8,Bars,MaPeriod2,0,MaMetod2,i);
   for(i=0; i<Bars; i++) ExtMapBuffer3[i]=iMAOnArray(ExtMapBuffer5,Bars,MaPeriod2,0,MaMetod2,i);
   for(i=0; i<Bars; i++) ExtMapBuffer4[i]=iMAOnArray(ExtMapBuffer6,Bars,MaPeriod2,0,MaMetod2,i);
//----
   return(0);
  }
//+------------------------------------------------------------------+






////////////////////////////////////////////////////////////////////////////////////
//  damn! thot I'd finished:
//  below is the SECOND code section of Tenners post
//  hahaaaa, not really take this in. ok, is the item that calls all of above via iCustom()
//  gotta do me own work for now. on-air agian 'sometime' near U...
////////////////////////////////////////////////////////////////////////////////////








Now the code for the 2nd indicator that will use the arrow values:

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Lime
#property indicator_color2 Red

#property indicator_width1 1
#property indicator_width2 1

extern string ___Heiken_Ashi_Smoothed___;
extern int MaM1 = 2;
extern int MaP1 = 6;     
extern int MaM2 = 3;
extern int MaP2 = 2;

//---- buffers
double arrowUpImg[];
double arrowDnImg[];
double signal[];

int arrowPos;
int ExtCountedBars=0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//|------------------------------------------------------------------|
int init()
  {
   arrowPos = ipm(Period());
//---- indicators
//----   
//---- indicator buffers mapping
    SetIndexBuffer(1,arrowUpImg);
    SetIndexStyle(1,DRAW_ARROW);
    SetIndexArrow(1,233); //241 option for different arrow head
    SetIndexBuffer(2,arrowDnImg);
    SetIndexStyle(2,DRAW_ARROW);
    SetIndexArrow(2,234); //242 option for different arrow head   
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   //double haOpen, haHigh, haLow, haClose;
   //double emb1,emb2,emb3,emb4,emb5,emb6,emb7,emb8;                  //external map buffers from Heiken_Ashi_Smoothed indicator
   int myBars = 1000; //used for testing ******
   
   if(Bars<=10) return(0);
   ExtCountedBars=IndicatorCounted();
//---- check for possible errors
   if (ExtCountedBars<0) return(-1);
//---- last counted bar will be recounted
   if (ExtCountedBars>0) ExtCountedBars--;
   int pos=Bars-ExtCountedBars-1;
   while(pos>=0)
     {
     int ppos = pos;
     signal[ppos] = iCustom(NULL,0,"Heiken_Ashi_Smoothed",MaM1,MaP1,MaM2,MaP2,6,0);

      if( signal[ppos] > 0 ){
         arrowUpImg[ppos] = iCustom(NULL,0,"Heiken_Ashi_Smoothed",MaM1,MaP1,MaM2,MaP2,4,0);
         arrowDnImg[ppos] = 0;
         Print("************************** Buy **************************");
      }
      else if ( signal[ppos] < 0 ){
         arrowUpImg[ppos] = 0;
         arrowDnImg[ppos] = iCustom(NULL,0,"Heiken_Ashi_Smoothed",MaM1,MaP1,MaM2,MaP2,5,0);
         Print("************************** Sell **************************");
      }
      else if ( signal[ppos] == 0 ){
         arrowUpImg[ppos] = 0; 
         arrowDnImg[ppos] = 0;
         Print("************************** No Signal **************************");
      }
           pos--;
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+

//--- Functions -----------------------------------------------------------------------
//+------------------------------------------------------------------+
//| Time Frame Dependent Arrow Placement                             |
//+------------------------------------------------------------------+
  
int ipm(double p)      //indicatorPositionMultiplier
{
   if (p == PERIOD_M1 ) return (5);
   if (p == PERIOD_M5 ) return (5);
   if (p == PERIOD_M15) return (5);
   if (p == PERIOD_M30) return (20);
   if (p == PERIOD_H1 ) return (20);
   if (p == PERIOD_H4 ) return (30);
   if (p == PERIOD_D1 ) return (75);
   if (p == PERIOD_W1 ) return (120);
   if (p == PERIOD_MN1) return (200);
}

